> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# List columns for all elements in a data model

GET https://api.sigmacomputing.com/v2/dataModels/{dataModelId}/columns

This endpoint retrieves all columns in a data model for all elements in the data model.

  ### Usage notes
  - Retrieve the **dataModelId** by calling the [/v2/dataModels](https://help.sigmacomputing.com/reference/list-data-models) endpoint.

  ### Usage scenarios
  - **Data exploration:** Enable users to explore the data structure of a data model element, facilitating deeper analysis and understanding.
  - **Integration tasks:** Useful for developers integrating Sigma with other tools that need to know the data structure to map data accurately.

  ### Best practices
  - Use this endpoint when setting up interfaces that require specific knowledge about the data structure.

Reference: https://help.sigmacomputing.com/reference/get-data-model-columns

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/dataModels/{dataModelId}/columns:
    get:
      operationId: getDataModelColumns
      summary: List columns for all elements in a data model
      description: >-
        This endpoint retrieves all columns in a data model for all elements in
        the data model.

          ### Usage notes
          - Retrieve the **dataModelId** by calling the [/v2/dataModels](https://help.sigmacomputing.com/reference/list-data-models) endpoint.

          ### Usage scenarios
          - **Data exploration:** Enable users to explore the data structure of a data model element, facilitating deeper analysis and understanding.
          - **Integration tasks:** Useful for developers integrating Sigma with other tools that need to know the data structure to map data accurately.

          ### Best practices
          - Use this endpoint when setting up interfaces that require specific knowledge about the data structure.
      tags:
        - dataModels
      parameters:
        - name: dataModelId
          in: path
          required: true
          schema:
            type: string
        - name: page
          in: query
          required: false
          schema:
            type: string
        - name: limit
          in: query
          required: false
          schema:
            type: number
            format: double
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/dataModels_getDataModelColumns_Response_200
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2DataModelsDataModelIdColumnsGetResponsesContentApplicationJsonSchemaEntriesItemsType:
      type: object
      properties: {}
      description: The column's data type, represented as a recursive type object.
      title: >-
        V2DataModelsDataModelIdColumnsGetResponsesContentApplicationJsonSchemaEntriesItemsType
    V2DataModelsDataModelIdColumnsGetResponsesContentApplicationJsonSchemaEntriesItems:
      type: object
      properties:
        columnId:
          type: string
          description: Column ID
        name:
          type: string
          description: Column name
        formula:
          type: string
          description: Column formula or source column reference.
        type:
          $ref: >-
            #/components/schemas/V2DataModelsDataModelIdColumnsGetResponsesContentApplicationJsonSchemaEntriesItemsType
          description: The column's data type, represented as a recursive type object.
        elementId:
          type: string
          description: Element ID
      required:
        - columnId
        - name
        - formula
        - type
        - elementId
      title: >-
        V2DataModelsDataModelIdColumnsGetResponsesContentApplicationJsonSchemaEntriesItems
    dataModels_getDataModelColumns_Response_200:
      type: object
      properties:
        entries:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2DataModelsDataModelIdColumnsGetResponsesContentApplicationJsonSchemaEntriesItems
        nextPage:
          type:
            - string
            - 'null'
        total:
          type: number
          format: double
      required:
        - entries
        - nextPage
      title: dataModels_getDataModelColumns_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Request**

```json
{}
```

**Response**

```json
{
  "entries": [
    {
      "columnId": "col_9f8b7a6d",
      "name": "Total Sales",
      "formula": "SUM(Sales.Amount)",
      "type": {
        "format": "decimal",
        "precision": 10,
        "scale": 2,
        "type": "number"
      },
      "elementId": "elem_4a3c2b1d"
    },
    {
      "columnId": "col_1a2b3c4d",
      "name": "Order Date",
      "formula": "Orders.OrderDate",
      "type": {
        "format": "yyyy-MM-dd",
        "type": "date"
      },
      "elementId": "elem_4a3c2b1d"
    },
    {
      "columnId": "col_5e6f7g8h",
      "name": "Customer Name",
      "formula": "Customers.Name",
      "type": {
        "maxLength": 255,
        "type": "string"
      },
      "elementId": "elem_7b8c9d0e"
    }
  ],
  "nextPage": null,
  "total": 3
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/dataModels/dataModelId/columns"

payload = {}
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/dataModels/dataModelId/columns';
const options = {
  method: 'GET',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/dataModels/dataModelId/columns"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/dataModels/dataModelId/columns")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.sigmacomputing.com/v2/dataModels/dataModelId/columns")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.sigmacomputing.com/v2/dataModels/dataModelId/columns', [
  'body' => '{}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/dataModels/dataModelId/columns");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/dataModels/dataModelId/columns")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```